//+------------------------------------------------------------------+							
//|                                          Order Management Partial Close EA.mq4 |							
//|                                                             Pooh |							
//|                                        http://www.metaquotes.net |							
//+------------------------------------------------------------------+							
#property copyright "Pooh"							
#property link      "http://www.metaquotes.net"							
							
//--- input parameters							
extern string    Comment1="Use actual pips, not 4-digit pips";							
extern int       TP_Pips=200;							
extern int       SL_Pips=200;							
extern int       TS_Pips=200;							
extern int       Slip=9;							
extern int       Magic=200123;							
extern int       NumOfTries=8;							
							
Comment("USE ACTUAL PIPS, NOT 4-DIGIT PIPS !!!");							
							
							
//+------------------------------------------------------------------+							
//| expert initialization function                                   |							
//+------------------------------------------------------------------+							
int init()							
  {							
//----							
 							
							
   							
//----							
   return(0);							
  }							
//+------------------------------------------------------------------+							
//| expert deinitialization function                                 |							
//+------------------------------------------------------------------+							
int deinit()							
  {							
//----							
   							
//----							
   return(0);							
  }							
//+------------------------------------------------------------------+							
//| expert start function                                            |							
//+------------------------------------------------------------------+							
int start()							
  {							
//----							
//if(iBars(NULL,0)<10 || IsTradeAllowed()==false)							
// return(0);							
   							
   int TTL;							
   TTL=0;							
							
    for (int m=0;m<=OrdersTotal();m++)							
      {							
      OrderSelect(m,SELECT_BY_POS,MODE_TRADES);							
      if(OrderSelect(m,SELECT_BY_POS,MODE_TRADES)==true)							
        {							
        if(OrderMagicNumber()==Magic && OrderSymbol()==Symbol())							
         TTL=TTL+1;							
                							
        }							
      }							
							
							
  string Gstatus=Symbol()+"_status";							
  string Gtrailprice=Symbol()+"_trailprice";							
  if(TTL==0 && GlobalVariableCheck(Gstatus))							
  globaldelete(Gstatus);							
							
							
							
   for(int i=OrdersTotal()-1;i>=0;i--)							
   {							
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);							
   if(OrderMagicNumber()==Magic && OrderSymbol()==Symbol())							
     {							
     if(OrderType()==OP_BUY)							
      {							
        if(MarketInfo(OrderSymbol(),MODE_BID)<=OrderOpenPrice()-Point*SL_Pips)							
        {							
        closeorder(OrderTicket(),OrderLots(),OrderType());							
        Print("Close buy order by stop loss");							
        return(0);							
        }							
      }							
    if(OrderType()==OP_SELL)							
     {							
      if(MarketInfo(OrderSymbol(),MODE_ASK)>=OrderOpenPrice()+Point*SL_Pips)							
      {							
      closeorder(OrderTicket(),OrderLots(),OrderType());							
      Print("Close sell order by stop loss");							
      return(0);							
      }							
     }							
							
  							
    if(!GlobalVariableCheck(Gstatus))							
    GlobalVariableSet(Gstatus,1.0);							
							
//close 1st half in profit							
							
   if(GlobalVariableGet(Gstatus)==1.0)							
    {							
     if(OrderType()==OP_BUY)							
     {							
       if(MarketInfo(OrderSymbol(),MODE_BID)>=OrderOpenPrice()+Point*TP_Pips)	
       {						
       closeorder(OrderTicket(),OrderLots()*0.5,OrderType());							
       Print("Close 1st half in profit");							
       GlobalVariableSet(Gtrailprice,OrderOpenPrice());							
       GlobalVariableSet(Gstatus,2.0);		
       }					
     }							
    if(OrderType()==OP_SELL)							
     {							
       if(MarketInfo(Symbol(),MODE_ASK)<=OrderOpenPrice()-Point*TP_Pips)							
       {
       closeorder(OrderTicket(),OrderLots()*0.5,OrderType());							
       Print("Close 1st half in profit");							
       GlobalVariableSet(Gtrailprice,OrderOpenPrice());							
       GlobalVariableSet(Gstatus,2.0);	
       }						
     }							
    }							
//------------------------------------------------------------------------------------------------------------------							
							
//Change trail price and close 2nd half							
							
  if(OrderType()==OP_BUY && GlobalVariableGet(Gstatus)==2.0)							
    {							
     if(MarketInfo(Symbol(),MODE_BID)>GlobalVariableGet(Gtrailprice)+Point*TS_Pips)							
     GlobalVariableSet(Gtrailprice,Bid-Point*TS_Pips);							
    if(MarketInfo(Symbol(),MODE_BID)<=GlobalVariableGet(Gtrailprice))							//change this statement if change close condition.
    {							
    closeorder(OrderTicket(),OrderLots(),OrderType());							
    Print("Close 2nd half by trailing stop",GlobalVariableGet(Gtrailprice));							
    globaldelete(Gstatus);							
    globaldelete(Gtrailprice);							
    }							
   }							
  if(OrderType()==OP_SELL && GlobalVariableGet(Gstatus)==2.0)							
   {							
   if(MarketInfo(Symbol(),MODE_ASK)<GlobalVariableGet(Gtrailprice)-Point*TS_Pips)							
   GlobalVariableSet(Gtrailprice,Ask+Point*TS_Pips);							
   if(MarketInfo(Symbol(),MODE_ASK)>=GlobalVariableGet(Gtrailprice))							//Change this statement if change close condition.
   {							
   closeorder(OrderTicket(),OrderLots(),OrderType());							
   Print("Close 2nd half by trailing stop",GlobalVariableGet(Gtrailprice));							
   globaldelete(Gstatus);							
   globaldelete(Gtrailprice);							
   }							
   }							
  }							
  }							
							
							
							
							
							
							
//----							
   return(0);							
  }							
//+------------------------------------------------------------------+							
							
							
							
  void globaldelete(string G_status)							
  {							
   GlobalVariableDel(G_status);							
   for(int j=1;j<=NumOfTries;j++)							
   {							
   if(!GlobalVariableCheck(G_status))							
   break;							
   else							
   GlobalVariableDel(G_status);							
   }							
  }							
							
							
 void closeorder(int ord_ticket,double ord_lot,int ord_type)							
   {							
      double cp;							
   bool result = false; 							
      							
   int tries=0;							
   while (!result && tries < NumOfTries) 							
   {							
      RefreshRates();							
      if(ord_type==OP_BUY) cp=NormalizeDouble(MarketInfo(Symbol(),MODE_BID),MarketInfo(Symbol(),MODE_DIGITS));							
      if(ord_type==OP_SELL) cp=NormalizeDouble(MarketInfo(Symbol(),MODE_ASK),MarketInfo(Symbol(),MODE_DIGITS));							
							
      result=OrderClose(ord_ticket,ord_lot,cp,Slip,Pink);							
      tries++;							
   }							
  if (!result) Print("Error closing order : ",GetLastError());							
							
  }							

